local ____lualib = require("lualib_bundle")
local Set = ____lualib.Set
local __TS__New = ____lualib.__TS__New
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local ____exports = {}
local ____isaac_2Dtypescript_2Ddefinitions = require("isaac-typescript-definitions")
local ModCallback = ____isaac_2Dtypescript_2Ddefinitions.ModCallback
local ____shouldFire = require("shouldFire")
local shouldFireLaser = ____shouldFire.shouldFireLaser
local ____CustomCallback = require("classes.private.CustomCallback")
local CustomCallback = ____CustomCallback.CustomCallback
local v = {room = {firedSet = __TS__New(Set)}}
____exports.PostLaserInitLate = __TS__Class()
local PostLaserInitLate = ____exports.PostLaserInitLate
PostLaserInitLate.name = "PostLaserInitLate"
__TS__ClassExtends(PostLaserInitLate, CustomCallback)
function PostLaserInitLate.prototype.____constructor(self)
    CustomCallback.prototype.____constructor(self)
    self.v = v
    self.shouldFire = shouldFireLaser
    self.postLaserUpdate = function(____, laser)
        local index = GetPtrHash(laser)
        if not v.room.firedSet:has(index) then
            v.room.firedSet:add(index)
            self:fire(laser)
        end
    end
    self.callbacksUsed = {{ModCallback.POST_LASER_UPDATE, self.postLaserUpdate}}
end
return ____exports
